var recorder = new RecordRTC_Extension();

var videoElemt = document.getElementsByTagName('video')[0];

function downloadBlob(blob){
    let self = this;
    let url = URL.createObjectURL(blob);
    let a = document.createElement('a');
    document.body.appendChild(a);
    a.style = 'display: none';
    a.href = url;
    a.download = `recoder.mp4`;
    a.click();
    a.remove();
    window.URL.revokeObjectURL(url);
}

function startRecording(){
    recorder.startRecording({
        enableTabCaptureAPI: true,
        enableTabCaptureAPIAudioOnly: false
    });
}

function replayVideo(video){
    video.pause();
    video.currentTime = '0';
    video.play();
}

function stopRecording(duration){
    setTimeout(function(){
        recorder.stopRecording(function(blob) {
            downloadBlob(blob);
        });
    },duration*1000);
}

function setFullScreen(elem){
    if (elem.requestFullscreen) {
        elem.requestFullscreen();
    } else if (elem.mozRequestFullScreen) {
        elem.mozRequestFullScreen();
    } else if (elem.webkitRequestFullscreen) {
        elem.webkitRequestFullscreen();
    } else if (elem.msRequestFullscreen) {
        elem.msRequestFullscreen();
    }
}

document.onkeydown = function(e){
    if(e.keyCode == 83 && e.altKey){  // alt + s = start
        setFullScreen(videoElemt);
        setTimeout(function(){
            replayVideo(videoElemt);
            startRecording();
            stopRecording(15);
        },5000);
	}
}